AppDomain.FirstChanceException AppDomain.FirstChanceException AppDomain.FirstChanceException AppDomain.FirstChanceException Event

Definizione

Si verifica quando un'eccezione viene generata in codice gestito prima che il runtime cerchi un gestore di eccezioni nello stack di chiamate del dominio applicazione.Occurs when an exception is thrown in managed code, before the runtime searches the call stack for an exception handler in the application domain.

public:
 event EventHandler<System::Runtime::ExceptionServices::FirstChanceExceptionEventArgs ^> ^ FirstChanceException;
[add: System.Security.SecurityCritical]
[remove: System.Security.SecurityCritical]
public event EventHandler<System.Runtime.ExceptionServices.FirstChanceExceptionEventArgs> FirstChanceException;
member this.FirstChanceException : EventHandler<System.Runtime.ExceptionServices.FirstChanceExceptionEventArgs> 
Public Custom Event FirstChanceException As EventHandler(Of FirstChanceExceptionEventArgs) 
Attributi

Esempi

L'esempio seguente crea una serie di domini dell'applicazione denominata AD0 attraverso AD3, con un Worker oggetto in ogni dominio applicazione.The following example creates a series of application domains named AD0 through AD3, with a Worker object in each application domain. Ogni Worker oggetto ha un riferimento al Worker dell'oggetto nel dominio dell'applicazione Avanti, fatta eccezione per il Worker nel dominio dell'applicazione ultimo.Each Worker object has a reference to the Worker object in the next application domain, except for the Worker in the last application domain. Il FirstChanceException evento viene gestito in tutti i domini applicazione, ad eccezione AD1.The FirstChanceException event is handled in all application domains except AD1.

Nota

Oltre a questo esempio, che illustra le notifiche di eccezioni first-chance in più domini applicazione, è possibile trovare casi di semplice utilizzo come: Ricevere notifiche di eccezioni First-Chance.In addition to this example, which demonstrates first-chance exception notifications in multiple application domains, you can find simple use cases in How to: Receive First-Chance Exception Notifications.

Quando sono stati creati i domini applicazione, il dominio applicazione predefinito chiama il TestException metodo per il primo dominio dell'applicazione.When the application domains have been created, the default application domain calls the TestException method for the first application domain. Ciascuna Worker object chiama il TestException metodo per il dominio di applicazione successivo, finché l'ultimo Worker genera un'eccezione che viene o non gestita.Each Worker object calls the TestException method for the next application domain, until the last Worker throws an exception that is either handled or unhandled. Di conseguenza, il thread corrente attraversa tutti i domini dell'applicazione e TestException viene aggiunta allo stack in ogni dominio applicazione.Thus, the current thread passes through all the application domains, and TestException is added to the stack in each application domain.

Quando l'ultima Worker oggetto gestisce l'eccezione, il FirstChanceException evento viene generato solo nel dominio dell'applicazione ultimo.When the last Worker object handles the exception, the FirstChanceException event is raised only in the last application domain. Gli altri domini applicazione mai l'opportunità di gestire l'eccezione, pertanto non viene generato l'evento.The other application domains never get a chance to handle the exception, so the event is not raised.

Quando l'ultima Worker oggetto non gestisce l'eccezione, il FirstChanceException in ogni dominio applicazione che dispone di un gestore di evento viene generato l'evento.When the last Worker object does not handle the exception, the FirstChanceException event is raised in each application domain that has an event handler. Al termine di ogni gestore eventi, lo stack continua a di rimozione fino a quando non viene rilevata l'eccezione per il dominio applicazione predefinito.After each event handler has finished, the stack continues to unwind until the exception is caught by the default application domain.

Nota

Per visualizzare la modalità di visualizzazione dello stack aumenta man mano che viene generato l'evento più vicino e più prossimo al dominio applicazione predefinito, modificare e.Exception.Message al e.Exception nel FirstChanceHandler gestori eventi.To see how the stack display grows as the event is raised closer and closer to the default application domain, change e.Exception.Message to e.Exception in the FirstChanceHandler event handlers. Si noti che quando TestException viene chiamato attraverso i limiti del dominio applicazione, viene visualizzato due volte: una volta per il proxy e una volta per lo stub.Notice that when TestException is called across application domain boundaries, it appears twice: once for the proxy and once for the stub.

using System;
using System.Reflection;
using System.Runtime.ExceptionServices;

class Example
{
    static void Main()
    {
        AppDomain.CurrentDomain.FirstChanceException += FirstChanceHandler;

        // Create a set of application domains, with a Worker object in each one.
        // Each Worker object creates the next application domain.
        AppDomain ad = AppDomain.CreateDomain("AD0");
        Worker w = (Worker) ad.CreateInstanceAndUnwrap(
                                typeof(Worker).Assembly.FullName, "Worker");
        w.Initialize(0, 3);

        Console.WriteLine("\r\nThe last application domain throws an exception and catches it:");
        Console.WriteLine();
        w.TestException(true);

        try
        {
            Console.WriteLine(
                "\r\nThe last application domain throws an exception and does not catch it:");
            Console.WriteLine();
            w.TestException(false);
        }
        catch (ArgumentException ex)
        {
            Console.WriteLine("ArgumentException caught in {0}: {1}", 
                AppDomain.CurrentDomain.FriendlyName, ex.Message);
        }
    }

    static void FirstChanceHandler(object source, FirstChanceExceptionEventArgs e)
    {
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message);
    }
}

public class Worker : MarshalByRefObject
{
    private AppDomain ad = null;
    private Worker w = null;

    public void Initialize(int count, int max)
    {
        // Handle the FirstChanceException event in all application domains except
        // AD1.
        if (count != 1)
        {
            AppDomain.CurrentDomain.FirstChanceException += FirstChanceHandler;
        }

        // Create another application domain, until the maximum is reached.
        // Field w remains null in the last application domain, as a signal
        // to TestException(). 
        if (count < max)
        {
            int next = count + 1;
            ad = AppDomain.CreateDomain("AD" + next);
            w = (Worker) ad.CreateInstanceAndUnwrap(
                             typeof(Worker).Assembly.FullName, "Worker");
            w.Initialize(next, max);
        }
    }

    public void TestException(bool handled)
    {
        // As long as there is another application domain, call TestException() on
        // its Worker object. When the last application domain is reached, throw a
        // handled or unhandled exception.
        if (w != null)
        {
            w.TestException(handled);
        }
        else if (handled)
        {
            try
            {
                throw new ArgumentException("Thrown in " + AppDomain.CurrentDomain.FriendlyName);
            }
            catch (ArgumentException ex)
            {
                Console.WriteLine("ArgumentException caught in {0}: {1}", 
                    AppDomain.CurrentDomain.FriendlyName, ex.Message);
            }
        }
        else
        {
            throw new ArgumentException("Thrown in " + AppDomain.CurrentDomain.FriendlyName);
        }
    }

    static void FirstChanceHandler(object source, FirstChanceExceptionEventArgs e)
    {
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message);
    }
}

/* This example produces output similar to the following:

The last application domain throws an exception and catches it:

FirstChanceException event raised in AD3: Thrown in AD3
ArgumentException caught in AD3: Thrown in AD3

The last application domain throws an exception and does not catch it:

FirstChanceException event raised in AD3: Thrown in AD3
FirstChanceException event raised in AD2: Thrown in AD3
FirstChanceException event raised in AD0: Thrown in AD3
FirstChanceException event raised in Example.exe: Thrown in AD3
ArgumentException caught in Example.exe: Thrown in AD3
 */
Imports System.Reflection
Imports System.Runtime.ExceptionServices

Class Example

    Shared Sub Main()
    
        AddHandler AppDomain.CurrentDomain.FirstChanceException, AddressOf FirstChanceHandler

        ' Create a set of application domains, with a Worker object in each one.
        ' Each Worker object creates the next application domain.
        Dim ad As AppDomain = AppDomain.CreateDomain("AD0")
        Dim w As Worker = CType(ad.CreateInstanceAndUnwrap(
                                GetType(Worker).Assembly.FullName, "Worker"),
                                Worker)
        w.Initialize(0, 3)

        Console.WriteLine(vbCrLf & "The last application domain throws an exception and catches it:")
        Console.WriteLine()
        w.TestException(true)

        Try
            Console.WriteLine(vbCrLf & 
                "The last application domain throws an exception and does not catch it:")
            Console.WriteLine()
            w.TestException(false) 

        Catch ex As ArgumentException
        
            Console.WriteLine("ArgumentException caught in {0}: {1}", 
                AppDomain.CurrentDomain.FriendlyName, ex.Message)
        End Try
    End Sub

    Shared Sub FirstChanceHandler(ByVal source As Object, 
                                  ByVal e As FirstChanceExceptionEventArgs)
    
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message)
    End Sub
End Class

Public Class Worker
    Inherits MarshalByRefObject

    Private ad As AppDomain = Nothing
    Private w As Worker = Nothing

    Public Sub Initialize(ByVal count As Integer, ByVal max As Integer)
    
        ' Handle the FirstChanceException event in all application domains except
        ' AD1.
        If count <> 1
        
            AddHandler AppDomain.CurrentDomain.FirstChanceException, AddressOf FirstChanceHandler

        End If

        ' Create another application domain, until the maximum is reached.
        ' Field w remains Nothing in the last application domain, as a signal 
        ' to TestException(). 
        If count < max
            Dim nextAD As Integer = count + 1
            ad = AppDomain.CreateDomain("AD" & nextAD)
            w = CType(ad.CreateInstanceAndUnwrap(
                      GetType(Worker).Assembly.FullName, "Worker"),
                      Worker)
            w.Initialize(nextAD, max)
        End If
    End Sub

    Public Sub TestException(ByVal handled As Boolean)
    
        ' As long as there is another application domain, call TestException() on
        ' its Worker object. When the last application domain is reached, throw a
        ' handled or unhandled exception.
        If w IsNot Nothing
        
            w.TestException(handled)

        Else If handled
        
            Try
                Throw New ArgumentException("Thrown in " & AppDomain.CurrentDomain.FriendlyName)

            Catch ex As ArgumentException
            
                Console.WriteLine("ArgumentException caught in {0}: {1}", 
                    AppDomain.CurrentDomain.FriendlyName, ex.Message)
            End Try
        Else
        
            Throw New ArgumentException("Thrown in " & AppDomain.CurrentDomain.FriendlyName)
        End If
    End Sub

    Shared Sub FirstChanceHandler(ByVal source As Object, 
                                  ByVal e As FirstChanceExceptionEventArgs)
    
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message)
    End Sub
End Class

' This example produces output similar to the following:
'
'The last application domain throws an exception and catches it:
'
'FirstChanceException event raised in AD3: Thrown in AD3
'ArgumentException caught in AD3: Thrown in AD3
'
'The last application domain throws an exception and does not catch it:
'
'FirstChanceException event raised in AD3: Thrown in AD3
'FirstChanceException event raised in AD2: Thrown in AD3
'FirstChanceException event raised in AD0: Thrown in AD3
'FirstChanceException event raised in Example.exe: Thrown in AD3
'ArgumentException caught in Example.exe: Thrown in AD3

Commenti

Questo evento è solo una notifica.This event is only a notification. Questo evento non gestire l'eccezione, né altera in alcun modo di gestione delle eccezioni successive.Handling this event does not handle the exception or affect subsequent exception handling in any way. Dopo che è stato generato l'evento e sono stati richiamati i gestori eventi, common language runtime (CLR) inizia a eseguire la ricerca di un gestore per l'eccezione.After the event has been raised and event handlers have been invoked, the common language runtime (CLR) begins to search for a handler for the exception. FirstChanceException fornisce il dominio dell'applicazione con una prima opportunità per esaminare qualsiasi eccezione gestita.FirstChanceException provides the application domain with a first chance to examine any managed exception.

L'evento può essere gestito per ogni dominio dell'applicazione.The event can be handled per application domain. Se un thread passa attraverso più domini dell'applicazione durante l'esecuzione di una chiamata, l'evento viene generato in ogni dominio applicazione che ha registrato un gestore eventi, prima che Common Language Runtime inizi la ricerca di un gestore di eccezioni corrispondente in tale dominio dell'applicazione.If a thread passes through multiple application domains while executing a call, the event is raised in each application domain that has registered an event handler, before the CLR begins searching for a matching exception handler in that application domain. Dopo l'evento è stato gestito, viene eseguita una ricerca per un gestore di eccezioni corrispondente in tale dominio dell'applicazione.After the event has been handled, a search is made for a matching exception handler in that application domain. Se non ne viene trovato, viene generato l'evento nel dominio dell'applicazione successivo.If none is found, the event is raised in the next application domain.

È necessario gestire tutte le eccezioni che si verificano nell'evento gestore per il FirstChanceException evento.You must handle all exceptions that occur in the event handler for the FirstChanceException event. In caso contrario, FirstChanceException viene generato in modo ricorsivo.Otherwise, FirstChanceException is raised recursively. Ciò potrebbe causare un overflow dello stack e la chiusura dell'applicazione.This could result in a stack overflow and termination of the application. Si consiglia di implementare i gestori eventi per questo evento come aree a esecuzione vincolata (CER), per evitare che interessano la macchina virtuale durante la notifica di eccezione è che le eccezioni correlate all'infrastruttura, ad esempio di memoria insufficiente o stack overflow in fase di elaborazione.We recommend that you implement event handlers for this event as constrained execution regions (CERs), to keep infrastructure-related exceptions such as out-of-memory or stack overflow from affecting the virtual machine while the exception notification is being processed.

Questo evento non viene generato per le eccezioni che indicano il danneggiamento dello stato del processo, ad esempio le violazioni di accesso, a meno che il gestore dell'evento è critico per la sicurezza e ha il HandleProcessCorruptedStateExceptionsAttribute attributo.This event is not raised for exceptions that indicate corruption of process state, such as access violations, unless the event handler is security-critical and has the HandleProcessCorruptedStateExceptionsAttribute attribute.

Common language runtime sospende le interruzioni di thread mentre viene gestito l'evento di notifica.The common language runtime suspends thread aborts while this notification event is being handled.

Sicurezza

SecurityCriticalAttribute
richiede l'attendibilità totale per il chiamante immediato.Requires full trust for the immediate caller. Questo membro non può essere utilizzato da codice parzialmente attendibile o trasparente.This member cannot be used by partially trusted or transparent code.

Si applica a

Vedi anche